Index: EcnlProtoTool/trunk/ntshell/ntshell/util/ntstdio.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/ntshell/util/ntstdio.c	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/ntshell/util/ntstdio.c	(revision 436)
@@ -292,5 +292,4 @@
 		return;
 	put_buf->outptr[handle->pos] = (char)c;
-	handle->pos++;
 }
 
@@ -307,5 +306,5 @@
 	handle.exinf = &exinf;
 	exinf.outptr = buf;
-	exinf.len = len;
+	exinf.len = len - 1; /* null char */
 
 	va_start(arp, fmt);
@@ -314,6 +313,6 @@
 
 	/* Terminate output string with a \0 */
-	buf[handle.pos] = '\0';
-	return result;
+	buf[result] = '\0';
+	return result;	/* not count null char */
 }
 
Index: EcnlProtoTool/trunk/ntshell/webserver/httpd-fs.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/httpd-fs.c	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/httpd-fs.c	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
- *
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  TOPPERS PROJECT Home Network Working Group Software
+ *
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  *
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -63,4 +63,6 @@
 #endif /* NULL */
 
+extern ntstdio_t ntstdio;
+
 /*-----------------------------------------------------------------------------------*/
 #ifdef FILE_DUMP
@@ -87,5 +89,5 @@
 			}
 			else {
-				syslog(LOG_ERROR, "%s/%s\n", path, fn);
+				ntstdio_printf(&ntstdio, "%s/%s\n", path, fn);
 			}
 		}
@@ -112,10 +114,10 @@
 	if ((res = f_open(fd, name, FA_OPEN_EXISTING | FA_READ)) != FR_OK) {
 		if ((res = f_opendir(&dir, name)) != FR_OK) {
-			syslog(LOG_ERROR, "f_opendir(%s) => %d\n", name, res);
+			ntstdio_printf(&ntstdio, "f_opendir(%s) => %d\n", name, res);
 			return 0;
 		}
 
 		if ((res = f_readdir(&dir, &fno)) != FR_OK) {
-			syslog(LOG_ERROR, "f_readdir(%s) => %d\n", name, res);
+			ntstdio_printf(&ntstdio, "f_readdir(%s) => %d\n", name, res);
 			return 0;
 		}
@@ -130,5 +132,5 @@
 
 		if (res != FR_OK) {
-			syslog(LOG_ERROR, "f_open(%s) => %d %x\n", name, res, fno.fattrib);
+			ntstdio_printf(&ntstdio, "f_open(%s) => %d %x\n", name, res, fno.fattrib);
 			return 0;
 		}
@@ -137,5 +139,5 @@
 	file->len = fd->fsize;
 
-	//syslog(LOG_ERROR, "httpd_fs_open(%d:%s) %d\n", drv, name, file->len);
+	//ntstdio_printf(&ntstdio, "httpd_fs_open(%s) %d\n", name, file->len);
 
 	return 1;
@@ -156,5 +158,5 @@
 
 	if ((res = f_open(fd, name, FA_CREATE_ALWAYS | FA_WRITE)) != FR_OK) {
-		syslog(LOG_ERROR, "f_open(%s) => %d\n", name, res);
+		ntstdio_printf(&ntstdio, "f_open(%s) => %d\n", name, res);
 		return 0;
 	}
@@ -163,5 +165,5 @@
 	file->len = 0;
 
-	//syslog(LOG_ERROR, "httpd_fs_create(%d:%s) %d\n", drv, name, file->len);
+	//ntstdio_printf(&ntstdio, "httpd_fs_create(%s) %d\n", file->name, file->len);
 
 	return 1;
@@ -177,18 +179,18 @@
 
 	if ((ret = f_lseek(fd, file->pos)) != FR_OK) {
-		syslog(LOG_ERROR, "f_lseek(%s, %d) => %d\n", file->name, file->pos, ret);
+		ntstdio_printf(&ntstdio, "f_lseek(%s, %d) => %d\n", file->name, file->pos, ret);
 		return 0;
 	}
 
 	if (file->pos != fd->fptr) {
-		syslog(LOG_ERROR, "f_lseek(%s, %d) != %d\n", file->name, file->pos, fd->fptr);
+		ntstdio_printf(&ntstdio, "f_lseek(%s, %d) != %d\n", file->name, file->pos, fd->fptr);
 	}
 
 	if ((ret = f_read(fd, dst, len, &rlen)) != FR_OK) {
-		syslog(LOG_ERROR, "f_read(%s, 0x%p, %d) => %d\n", file->name, dst, len, ret);
-		return 0;
-	}
-
-	//syslog(LOG_ERROR, "httpd_fs_read(%d:%s, %d, %d) => %d\n", file->drv, file->name, file->pos, len, rlen);
+		ntstdio_printf(&ntstdio, "f_read(%s, 0x%p, %d) => %d\n", file->name, dst, len, ret);
+		return 0;
+	}
+
+	//ntstdio_printf(&ntstdio, "httpd_fs_read(%s, %d, %d) => %d\n", file->name, file->pos, len, rlen);
 
 	return rlen;
@@ -204,14 +206,14 @@
 
 	if ((ret = f_lseek(fd, file->pos)) != FR_OK) {
-		syslog(LOG_ERROR, "f_lseek(%s, %d) => %d\n", file->name, file->pos, ret);
+		ntstdio_printf(&ntstdio, "f_lseek(%s, %d) => %d\n", file->name, file->pos, ret);
 		return 0;
 	}
 
 	if (file->pos != fd->fptr) {
-		syslog(LOG_ERROR, "f_lseek(%s, %d) != %d\n", file->name, file->pos, fd->fptr);
+		ntstdio_printf(&ntstdio, "f_lseek(%s, %d) != %d\n", file->name, file->pos, fd->fptr);
 	}
 
 	if ((ret = f_write(fd, src, len, &rlen)) != FR_OK) {
-		syslog(LOG_ERROR, "f_write(%s, 0x%p, %d) => %d\n", file->name, src, len, ret);
+		ntstdio_printf(&ntstdio, "f_write(%s, 0x%p, %d) => %d\n", file->name, src, len, ret);
 		return 0;
 	}
@@ -220,5 +222,5 @@
 	file->len += rlen;
 
-	//syslog(LOG_ERROR, "httpd_fs_write(%d:%s, %d, %d) => %d\n", file->drv, file->name, file->pos, len, rlen);
+	//ntstdio_printf(&ntstdio, "httpd_fs_write(%s, %d, %d) => %d\n", file->name, file->pos, len, rlen);
 
 	return rlen;
@@ -232,5 +234,5 @@
 
 	if ((ret = f_close(fd)) != FR_OK) {
-		syslog(LOG_ERROR, "f_close(%s) => %d\n", file->name, ret);
+		ntstdio_printf(&ntstdio, "f_close(%s) => %d\n", file->name, ret);
 		return 0;
 	}
Index: EcnlProtoTool/trunk/ntshell/webserver/httpd-fs.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/httpd-fs.h	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/httpd-fs.h	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  *
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  *
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/ntshell/webserver/httpd.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/httpd.c	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/httpd.c	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  *
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  *
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -62,7 +62,5 @@
 SYSTIM httpd_time;
 struct httpd_state *uploding;
-extern char command[256];
-
-extern int execute_command(int wait);
+static char command[256];
 
 /*  TCP 送受信ウィンドバッファ  */
@@ -367,5 +365,5 @@
 
 	if (s->message.body_is_final) {
-		syslog(LOG_ERROR, "\n\n *** Error http_body_is_final() should return 1 "
+		ntstdio_printf(&ntstdio, "\n\n *** Error http_body_is_final() should return 1 \n"
 			"on last on_body callback call "
 			"but it doesn't! ***\n\n");
@@ -405,5 +403,5 @@
 	struct httpd_state *s = get_context(p);
 	if (s->message.should_keep_alive != http_should_keep_alive(p)) {
-		syslog(LOG_ERROR, "\n\n *** Error http_should_keep_alive() should have same "
+		ntstdio_printf(&ntstdio, "\n\n *** Error http_should_keep_alive() should have same \n"
 			"value in both on_message_complete and on_headers_complete "
 			"but it doesn't! ***\n\n");
@@ -414,5 +412,5 @@
 		http_body_is_final(p) &&
 		!s->message.body_is_final) {
-		syslog(LOG_ERROR, "\n\n *** Error http_body_is_final() should return 1 "
+		ntstdio_printf(&ntstdio, "\n\n *** Error http_body_is_final() should return 1 \n"
 			"on last on_body callback call "
 			"but it doesn't! ***\n\n");
@@ -486,5 +484,5 @@
 		slen = tcp_get_buf(s->cepid, (void **)&buf, TMO_FEVR);
 		if (slen < 0) {
-			syslog(LOG_ERROR, "send_file#tcp_get_buf(%s.%d) => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
+			ntstdio_printf(&ntstdio, "send_file#tcp_get_buf(%s.%d) => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
 			s->state = STATE_CLOSING;
 			break;
@@ -499,5 +497,5 @@
 		len = httpd_fs_read(&s->file, buf, len);
 		if (len <= 0) {
-			syslog(LOG_ERROR, "send_file#httpd_fs_read(%s.%d) => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, len);
+			ntstdio_printf(&ntstdio, "send_file#httpd_fs_read(%s.%d) => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, len);
 			break;
 		}
@@ -507,5 +505,5 @@
 
 		if ((slen = tcp_snd_buf(s->cepid, len)) != E_OK) {
-			syslog(LOG_ERROR, "send_file#tcp_snd_buf(%s.%d) => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
+			ntstdio_printf(&ntstdio, "send_file#tcp_snd_buf(%s.%d) => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
 			s->state = STATE_CLOSING;
 			break;
@@ -529,5 +527,5 @@
 		slen = tcp_get_buf(s->cepid, (void **)&buf, TMO_FEVR);
 		if (slen < 0) {
-			syslog(LOG_ERROR, "send_data#tcp_get_buf(%s.%d) => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
+			ntstdio_printf(&ntstdio, "send_data#tcp_get_buf(%s.%d) => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
 			s->state = STATE_CLOSING;
 			break;
@@ -546,5 +544,5 @@
 
 		if ((slen = tcp_snd_buf(s->cepid, len)) != E_OK) {
-			syslog(LOG_ERROR, "send_data#tcp_snd_buf(%s.%d) => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
+			ntstdio_printf(&ntstdio, "send_data#tcp_snd_buf(%s.%d) => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
 			s->state = STATE_CLOSING;
 			break;
@@ -660,6 +658,6 @@
 		len = sizeof(http_content_length) - 1;
 		tcp_snd_dat(s->cepid, (void *)http_content_length, len, TMO_FEVR);
-		ntstdio_snprintf(s->temp, sizeof(s->temp), "%d\r\n", s->file.len);
-		tcp_snd_dat(s->cepid, (void *)s->temp, ntlibc_strlen(s->temp), TMO_FEVR);
+		len = ntstdio_snprintf(s->temp, sizeof(s->temp), "%d\r\n", s->file.len);
+		tcp_snd_dat(s->cepid, (void *)s->temp, len, TMO_FEVR);
 	}
 
@@ -706,20 +704,26 @@
 		break;
 	case OUT_STATE_WAIT_POST_BODY:
+		//ntstdio_printf(&ntstdio, "wait post body\n");
 		s->out.wait = true;
 		break;
 	case OUT_STATE_BODY_RECEIVED:
+		//ntstdio_printf(&ntstdio, "body received\n");
 		s->out.statushdr = http_header_200;
 		s->out.state = OUT_STATE_SEND_HEADER;
 		break;
 	case OUT_STATE_SEND_HEADER:
+		//ntstdio_printf(&ntstdio, "send header\n");
 		send_headers(s, s->out.statushdr);
 		break;
 	case OUT_STATE_SEND_FILE:
+		//ntstdio_printf(&ntstdio, "send file %d\n", s->file.len);
 		send_file(s);
 		break;
 	case OUT_STATE_SEND_DATA:
+		//ntstdio_printf(&ntstdio, "send data %d\n", s->response_len);
 		send_data(s);
 		break;
 	case OUT_STATE_SEND_END:
+		//ntstdio_printf(&ntstdio, "send end\n");
 		s->out.wait = true;
 		if (s->message.should_keep_alive && s->reset == 0) {
@@ -779,5 +783,5 @@
 	slen = tcp_get_buf(s->cepid, (void **)&buf, TMO_FEVR);
 	if (slen < 0) {
-		syslog(LOG_ERROR, "send_ws_data#tcp_get_buf(%s.%d) => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
+		ntstdio_printf(&ntstdio, "send_ws_data#tcp_get_buf(%s.%d) => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, slen);
 		return;
 	}
@@ -843,5 +847,5 @@
 				//}
 			}
-			syslog(LOG_ERROR, "handle_input#tcp_rcv_buf#%d(%s.%d) => %d", s->in.state, s->addr, ((T_IPV4EP *)s->dst)->portno, len);
+			ntstdio_printf(&ntstdio, "handle_input#tcp_rcv_buf#%d(%s.%d) => %d\n", s->in.state, s->addr, ((T_IPV4EP *)s->dst)->portno, len);
 			uploding = NULL;
 			s->state = STATE_CLOSING;
@@ -851,5 +855,5 @@
 		tcp_rel_buf(s->cepid, done);
 		if (s->parser.http_errno != HPE_OK) {
-			syslog(LOG_ERROR, "http_parser error %s.%d => %d", s->addr, ((T_IPV4EP *)s->dst)->portno, s->parser.http_errno);
+			ntstdio_printf(&ntstdio, "http_parser error %s.%d => %d\n", s->addr, ((T_IPV4EP *)s->dst)->portno, s->parser.http_errno);
 			uploding = NULL;
 			s->state = STATE_CLOSING;
@@ -876,5 +880,5 @@
 					break;
 				}
-				syslog(LOG_ERROR, "handle_input#tcp_rcv_buf#%d(%s.%d) => %d", s->in.state, s->addr, ((T_IPV4EP *)s->dst)->portno, len);
+				ntstdio_printf(&ntstdio, "handle_input#tcp_rcv_buf#%d(%s.%d) => %d\n", s->in.state, s->addr, ((T_IPV4EP *)s->dst)->portno, len);
 				s->state = STATE_CLOSING;
 				break;
@@ -932,5 +936,5 @@
 		ret2 = get_tim(&httpd_time);
 		if (ret2 != E_OK) {
-			syslog(LOG_ERROR, "get_tim");
+			ntstdio_printf(&ntstdio, "get_tim\n");
 			return;
 		}
@@ -939,7 +943,7 @@
 		case STATE_DISCONNECTED:
 			memset(&s->dst, 0, sizeof(s->dst));
-			if ((ret = TCP_ACP_CEP(s->cepid, TCP_REPID, (T_IPV4EP *)s->dst, TMO_FEVR)) != E_OK) {
-				syslog(LOG_ERROR, "tcp_acp_cep(%d) => %d", s->cepid, ret);
-				tslp_tsk(100);	// TODO
+			if ((ret = tcp_acp_cep(s->cepid, TCP_REPID, (T_IPV4EP *)s->dst, TMO_FEVR)) != E_OK) {
+				ntstdio_printf(&ntstdio, "tcp_acp_cep(%d) => %d\n", s->cepid, ret);
+				tslp_tsk(100 * 1000);	// TODO
 				s->state = STATE_CLOSING;
 				break;
@@ -974,5 +978,5 @@
 			break;
 		case STATE_RESET:
-			execute_command(0);
+			cmd_execute(command, NULL);
 			s->state = STATE_DISCONNECTED;
 			break;
@@ -980,6 +984,6 @@
 
 		if (s->in.wait && s->out.wait) {
-			tslp_tsk(100);
-		}
-	}
-}
+			tslp_tsk(100 * 1000);
+		}
+	}
+}
Index: EcnlProtoTool/trunk/ntshell/webserver/httpd.cfg
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/httpd.cfg	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/httpd.cfg	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  * 
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/ntshell/webserver/httpd.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/httpd.h	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/httpd.h	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  *
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  *
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/ntshell/webserver/tinet_httpd.cfg
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/tinet_httpd.cfg	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/tinet_httpd.cfg	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  * 
- *  Copyright (C) 2016 Cores Co., Ltd. Japan
+ *  Copyright (C) 2016-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -46,5 +46,5 @@
 #ifdef SUPPORT_INET6
 
-TCP6_CRE_REP (TCP_REPID, { 0, { IPV6_ADDRANY, 80 } } );
+TCP6_CRE_REP (TCP6_REPID, { 0, { IPV6_ADDRANY, 80 } } );
 
 #endif	/* of #ifdef SUPPORT_INET6 */
@@ -60,5 +60,5 @@
 #ifdef SUPPORT_INET6
 
-TCP6_CRE_CEP (TCP_CEPID1, {
+TCP6_CRE_CEP (TCP6_CEPID1, {
 	0,
 	tcp_swbuf1,
@@ -69,5 +69,5 @@
 	} );
 
-TCP6_CRE_CEP (TCP_CEPID2, {
+TCP6_CRE_CEP (TCP6_CEPID2, {
 	0,
 	tcp_swbuf2,
Index: EcnlProtoTool/trunk/ntshell/webserver/websocket.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/websocket.c	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/websocket.c	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
- * 
- *  Copyright (C) 2015 Cores Co., Ltd. Japan
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2015-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/ntshell/webserver/websocket.cfg
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/websocket.cfg	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/websocket.cfg	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  * 
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/ntshell/webserver/websocket.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/websocket.h	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/websocket.h	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS ECHONET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  * 
- *  Copyright (C) 2015 Cores Co., Ltd. Japan
+ *  Copyright (C) 2015-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
Index: EcnlProtoTool/trunk/ntshell/webserver/websocket_fbs.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/websocket_fbs.c	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/websocket_fbs.c	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS WEBSOCKET Lite Communication Middleware
+ *  TOPPERS PROJECT Home Network Working Group Software
  * 
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -47,4 +47,7 @@
 #include "websocket_fbs.h"
 
+void *sys_malloc(size_t size);
+void sys_free(void *ptr);
+
 static ER get_message(T_WS_FST_BLK **ppk_msg, int size)
 {
@@ -78,8 +81,11 @@
 		return E_PAR;
 
-	ret = pget_mpf(ws_mempoolid, &blk);
+#ifndef NOUSE_MPF_NET_BUF
+	ret = tget_mpf(ws_mempoolid, &blk, WEBSOCKET_MEMPOOL_GET_TMO);
 	if (ret != E_OK)
 		return ret;
-
+#else
+	blk = sys_malloc(size);
+#endif
 	memset(blk, 0, WEBSOCKET_MEMPOOL_BLOCK_SIZE);
 	*ppk_msg = (T_WS_FST_BLK *)(blk);
@@ -122,8 +128,11 @@
 		if (exp) {
 			if (mblk == NULL) {
-				ret = get_mpf(ws_mempoolid, &blk);
+#ifndef NOUSE_MPF_NET_BUF
+				ret = tget_mpf(ws_mempoolid, &blk, WEBSOCKET_MEMPOOL_GET_TMO);
 				if (ret != E_OK)
 					return NULL;
-
+#else
+				blk = sys_malloc(size);
+#endif
 				mblk = (T_WS_SUB_BLK *)(blk);
 
@@ -153,10 +162,20 @@
 			continue;
 
+#ifndef NOUSE_MPF_NET_BUF
 		ret = rel_mpf(ws_mempoolid, blk);
 		if (ret != E_OK)
 			return ret;
-	}
-
+#else
+		sys_free(blk);
+#endif
+	}
+
+#ifndef NOUSE_MPF_NET_BUF
 	return rel_mpf(ws_mempoolid, pk_msg);
+#else
+	sys_free(pk_msg);
+
+	return E_OK;
+#endif
 }
 
@@ -285,7 +304,11 @@
 		return NULL;
 
+#ifndef NOUSE_MPF_NET_BUF
 	ret = get_mpf(ws_mempoolid, &result);
 	if (ret != E_OK)
 		return NULL;
+#else
+	result = sys_malloc(fa_req_size);
+#endif
 
 	memset(result, 0, WEBSOCKET_MEMPOOL_BLOCK_SIZE);
@@ -297,5 +320,11 @@
 ER _ws_fbs_mbx_rel(void *p)
 {
+#ifndef NOUSE_MPF_NET_BUF
 	return rel_mpf(ws_mempoolid, p);
+#else
+	sys_free(p);
+
+	return E_OK;
+#endif
 }
 
Index: EcnlProtoTool/trunk/ntshell/webserver/websocket_fbs.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/websocket_fbs.h	(revision 435)
+++ EcnlProtoTool/trunk/ntshell/webserver/websocket_fbs.h	(revision 436)
@@ -1,6 +1,6 @@
 /*
- *  TOPPERS WEBSOCKET Lite Communication Middleware
- * 
- *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
  * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ