Index: EcnlProtoTool/trunk/webapp/webmrbc/copy.bat
===================================================================
--- EcnlProtoTool/trunk/webapp/webmrbc/copy.bat	(revision 439)
+++ EcnlProtoTool/trunk/webapp/webmrbc/copy.bat	(revision 445)
@@ -1,17 +1,17 @@
-del /Q /S ..\..\httpd-fs
+del /Q /S ..\..\ntshell\rom_fs\www
 
-mkdir ..\..\httpd-fs
-mkdir ..\..\httpd-fs\ace
-mkdir ..\..\httpd-fs\bootstrap
-mkdir ..\..\httpd-fs\bootstrap\css
-mkdir ..\..\httpd-fs\bootstrap\fonts
-mkdir ..\..\httpd-fs\bootstrap\js
-mkdir ..\..\httpd-fs\css
-mkdir ..\..\httpd-fs\img
-mkdir ..\..\httpd-fs\js
-mkdir ..\..\httpd-fs\xterm
-mkdir ..\..\httpd-fs\xterm\addons
-mkdir ..\..\httpd-fs\xterm\addons\fit
-mkdir ..\..\httpd-fs\xterm\src
+mkdir ..\..\ntshell\rom_fs\www
+mkdir ..\..\ntshell\rom_fs\www\ace
+mkdir ..\..\ntshell\rom_fs\www\bootstrap
+mkdir ..\..\ntshell\rom_fs\www\bootstrap\css
+mkdir ..\..\ntshell\rom_fs\www\bootstrap\fonts
+mkdir ..\..\ntshell\rom_fs\www\bootstrap\js
+mkdir ..\..\ntshell\rom_fs\www\css
+mkdir ..\..\ntshell\rom_fs\www\img
+mkdir ..\..\ntshell\rom_fs\www\js
+mkdir ..\..\ntshell\rom_fs\www\xterm
+mkdir ..\..\ntshell\rom_fs\www\xterm\addons
+mkdir ..\..\ntshell\rom_fs\www\xterm\addons\fit
+mkdir ..\..\ntshell\rom_fs\www\xterm\src
 
 rem java -jar ..\..\tools\yuicompressor-2.4.8.jar mrbc.js -o mrbc.min.js
@@ -25,37 +25,35 @@
 java -jar ..\..\tools\yuicompressor-2.4.8.jar xterm\src\xterm.js -o xterm\src\xterm.min.js
 
-copy /Y ace\ace.min.js ..\..\httpd-fs\ace\ace.js
-copy /Y ace\mode-ruby.min.js ..\..\httpd-fs\ace\mode-ruby.js
-copy /Y ace\theme-twilight.min.js ..\..\httpd-fs\ace\theme-twilight.js
-copy /Y arduino_toolbox.xml ..\..\httpd-fs\arduino_toolbox.xml
-copy /Y bootstrap\css\bootstrap-theme.min.css ..\..\httpd-fs\bootstrap\css\bootstrap-theme.min.css
-copy /Y bootstrap\css\bootstrap.min.css ..\..\httpd-fs\bootstrap\css\bootstrap.min.css
-copy /Y bootstrap\fonts\glyphicons-halflings-regular.eot ..\..\httpd-fs\bootstrap\fonts\glyphicons-halflings-regular.eot
-copy /Y bootstrap\fonts\glyphicons-halflings-regular.svg ..\..\httpd-fs\bootstrap\fonts\glyphicons-halflings-regular.svg
-copy /Y bootstrap\fonts\glyphicons-halflings-regular.ttf ..\..\httpd-fs\bootstrap\fonts\glyphicons-halflings-regular.ttf
-copy /Y bootstrap\fonts\glyphicons-halflings-regular.woff ..\..\httpd-fs\bootstrap\fonts\glyphicons-halflings-regular.woff
-copy /Y bootstrap\fonts\glyphicons-halflings-regular.woff2 ..\..\httpd-fs\bootstrap\fonts\glyphicons-halflings-regular.woff2
-copy /Y bootstrap\js\bootstrap.min.js ..\..\httpd-fs\bootstrap\js\bootstrap.min.js
-copy /Y css\webmrbc.min.css ..\..\httpd-fs\css\webmrbc.css
-copy /Y echonet_objects.min.json ..\..\httpd-fs\echonet_objects.json
-copy /Y ecnl_toolbox.xml ..\..\httpd-fs\ecnl_toolbox.xml
-copy /Y favicon.ico ..\..\httpd-fs\favicon.ico
-copy /Y img\banner.svg ..\..\httpd-fs\img\banner.svg
-copy /Y img\core-s.svg ..\..\httpd-fs\img\core-s.svg
-copy /Y img\no_image.png ..\..\httpd-fs\img\no_image.png
-copy /Y index.min.html ..\..\httpd-fs\index.html
-copy /Y information.json ..\..\httpd-fs\information.json
-copy /Y js\FileSaver.min.js ..\..\httpd-fs\js\FileSaver.min.js
-copy /Y js\jquery-3.1.0.min.js ..\..\httpd-fs\js\jquery-3.1.0.min.js
-copy /Y js\jszip.min.js ..\..\httpd-fs\js\jszip.min.js
-copy /Y /B js\blockly_compressed.js + js\bridge.min.js + js\webmrbc.min.js ..\..\httpd-fs\js\webmrbc.min.js
-copy /Y mrbc.min.js ..\..\httpd-fs\mrbc.min.js
-copy /Y mrbc.wasm ..\..\httpd-fs\mrbc.wasm
-copy /Y xterm\addons\fit\fit.min.js ..\..\httpd-fs\xterm\addons\fit\fit.js
-copy /Y xterm\src\xterm.min.css ..\..\httpd-fs\xterm\src\xterm.css
-copy /Y xterm\src\xterm.min.js ..\..\httpd-fs\xterm\src\xterm.js
+copy /Y ace\ace.min.js ..\..\ntshell\rom_fs\www\ace\ace.js
+copy /Y ace\mode-ruby.min.js ..\..\ntshell\rom_fs\www\ace\mode-ruby.js
+copy /Y ace\theme-twilight.min.js ..\..\ntshell\rom_fs\www\ace\theme-twilight.js
+copy /Y arduino_toolbox.xml ..\..\ntshell\rom_fs\www\arduino_toolbox.xml
+copy /Y bootstrap\css\bootstrap-theme.min.css ..\..\ntshell\rom_fs\www\bootstrap\css\bootstrap-theme.min.css
+copy /Y bootstrap\css\bootstrap.min.css ..\..\ntshell\rom_fs\www\bootstrap\css\bootstrap.min.css
+copy /Y bootstrap\fonts\glyphicons-halflings-regular.eot ..\..\ntshell\rom_fs\www\bootstrap\fonts\glyphicons-halflings-regular.eot
+copy /Y bootstrap\fonts\glyphicons-halflings-regular.svg ..\..\ntshell\rom_fs\www\bootstrap\fonts\glyphicons-halflings-regular.svg
+copy /Y bootstrap\fonts\glyphicons-halflings-regular.ttf ..\..\ntshell\rom_fs\www\bootstrap\fonts\glyphicons-halflings-regular.ttf
+copy /Y bootstrap\fonts\glyphicons-halflings-regular.woff ..\..\ntshell\rom_fs\www\bootstrap\fonts\glyphicons-halflings-regular.woff
+copy /Y bootstrap\fonts\glyphicons-halflings-regular.woff2 ..\..\ntshell\rom_fs\www\bootstrap\fonts\glyphicons-halflings-regular.woff2
+copy /Y bootstrap\js\bootstrap.min.js ..\..\ntshell\rom_fs\www\bootstrap\js\bootstrap.min.js
+copy /Y css\webmrbc.min.css ..\..\ntshell\rom_fs\www\css\webmrbc.css
+copy /Y echonet_objects.min.json ..\..\ntshell\rom_fs\www\echonet_objects.json
+copy /Y ecnl_toolbox.xml ..\..\ntshell\rom_fs\www\ecnl_toolbox.xml
+copy /Y favicon.ico ..\..\ntshell\rom_fs\www\favicon.ico
+copy /Y img\banner.svg ..\..\ntshell\rom_fs\www\img\banner.svg
+copy /Y img\core-s.svg ..\..\ntshell\rom_fs\www\img\core-s.svg
+copy /Y img\no_image.png ..\..\ntshell\rom_fs\www\img\no_image.png
+copy /Y index.min.html ..\..\ntshell\rom_fs\www\index.html
+copy /Y information.json ..\..\ntshell\rom_fs\www\information.json
+copy /Y js\FileSaver.min.js ..\..\ntshell\rom_fs\www\js\FileSaver.min.js
+copy /Y js\jquery-3.1.0.min.js ..\..\ntshell\rom_fs\www\js\jquery-3.1.0.min.js
+copy /Y js\jszip.min.js ..\..\ntshell\rom_fs\www\js\jszip.min.js
+copy /Y /B js\blockly_compressed.js + js\bridge.min.js + js\webmrbc.min.js ..\..\ntshell\rom_fs\www\js\webmrbc.min.js
+copy /Y mrbc.min.js ..\..\ntshell\rom_fs\www\mrbc.min.js
+copy /Y mrbc.wasm ..\..\ntshell\rom_fs\www\mrbc.wasm
+copy /Y xterm\addons\fit\fit.min.js ..\..\ntshell\rom_fs\www\xterm\addons\fit\fit.js
+copy /Y xterm\src\xterm.min.css ..\..\ntshell\rom_fs\www\xterm\src\xterm.css
+copy /Y xterm\src\xterm.min.js ..\..\ntshell\rom_fs\www\xterm\src\xterm.js
 
-CD ..\..\
-call tools\makefsdata.exe
-
-copy /Y httpd-fs.bin ntshell\webserver\httpd_fs.bin
+CD ..\..\ntshell
+call ..\tools\makefsdata.exe